﻿using System.Diagnostics;
using Microsoft.AspNetCore.Mvc;
using QuickMaster.Models;

namespace QuickMaster.Controllers;

public class HomeController : Controller
{
    private readonly ILogger<HomeController> _logger;

    public HomeController(ILogger<HomeController> logger)
    {
        _logger = logger;
    }

    public IActionResult Index()
    {
        return View();
    }

    // [Route("hoge/foo")]
    public IActionResult Privacy()
    {
        return View();
    }

    public IActionResult Article(int id)
    {
        return Content($"記事番号：{id}");
    }

    public IActionResult ArticleComplex(string forum, string category, string author, string id)
    {
        return Content($"{forum}..{category}..{author}..{id}");
    }

    
    public IActionResult Search(string keywords)
    {
        return Content($"キーワード：{keywords}");
    }


    [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
    public IActionResult Error()
    {
        return View(new ErrorViewModel { RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier });
    }
}
