using Microsoft.EntityFrameworkCore;
using QuickMaster.Filters;
using QuickMaster.Models;

var builder = WebApplication.CreateBuilder(args);

// Add services to the container.
builder.Services.AddControllersWithViews(/*options => {
  options.Filters.Add<MyLogAttribute>();
}*/);

builder.Services.AddDbContext<MyContext>(options =>
  options.UseSqlServer(
    builder.Configuration.GetConnectionString("MyContext")));



var app = builder.Build();

// Configure the HTTP request pipeline.
if (!app.Environment.IsDevelopment())
{
    app.UseExceptionHandler("/Home/Error");
}
app.UseStaticFiles();

app.UseRouting();

app.UseAuthorization();


app.MapControllerRoute(
    name: "default",
    pattern: "{controller=Home}/{action=Index}/{id?}"//,
    // constraints: new
    //   {
    //     id = @"\d{1,3}"
    //   }
    );

app.MapControllerRoute(
  name: "ArticleRoute",
  pattern: "article/{id}",
  defaults: new
  {
    controller = "Home",
    action = "Article"
  }
);

app.MapControllerRoute(
  name: "ArticleRouteComplex",
  pattern: "article/{forum}_{category}/{author}-{id}",
  //pattern: "article/{forum}X{category}/{author}-{id}",
  defaults: new
  {
    controller = "Home",
    action = "ArticleComplex"
  }
);

app.MapControllerRoute(
  name: "SearchArgs",
  pattern: "search/{*keywords}",
  defaults: new
  {
    controller = "Home",
    action = "Search"
  }
);


app.Run();
